(function(){var expandIPv6,ipaddr,ipv4Part,ipv4Regexes,ipv6Part,ipv6Regexes,matchCIDR,root;ipaddr={};root=this;if(typeof module!=="undefined"&&module!==null&&module.exports){module.exports=ipaddr}else{root["ipaddr"]=ipaddr}matchCIDR=function(first,second,partSize,cidrBits){var part,shift;if(first.length!==second.length){throw new Error("ipaddr: cannot match CIDR for objects with different lengths")}part=0;while(cidrBits>0){shift=partSize-cidrBits;if(shift<0){shift=0}if(first[part]>>shift!==second[part]>>shift){return false}cidrBits-=partSize;part+=1}return true};ipaddr.subnetMatch=function(address,rangeList,defaultName){var i,len,rangeName,rangeSubnets,subnet;if(defaultName==null){defaultName="unicast"}for(rangeName in rangeList){rangeSubnets=rangeList[rangeName];if(toString.call(rangeSubnets[0])!=="[object Array]"){rangeSubnets=[rangeSubnets]}for(i=0,len=rangeSubnets.length;i<len;i++){subnet=rangeSubnets[i];if(address.match.apply(address,subnet)){return rangeName}}}return defaultName};ipaddr.IPv4=function(){function IPv4(octets){var i,len,octet;if(octets.length!==4){throw new Error("ipaddr: ipv4 octet count should be 4")}for(i=0,len=octets.length;i<len;i++){octet=octets[i];if(!(0<=octet&&octet<=255)){throw new Error("ipaddr: ipv4 octet is a byte")}}this.octets=octets}IPv4.prototype.kind=function(){return"ipv4"};IPv4.prototype.toString=function(){return this.octets.join(".")};IPv4.prototype.toByteArray=function(){return this.octets.slice(0)};IPv4.prototype.match=function(other,cidrRange){if(other.kind()!=="ipv4"){throw new Error("ipaddr: cannot match ipv4 address with non-ipv4 one")}return matchCIDR(this.octets,other.octets,8,cidrRange)};IPv4.prototype.SpecialRanges={broadcast:[[new IPv4([255,255,255,255]),32]],multicast:[[new IPv4([224,0,0,0]),4]],linkLocal:[[new IPv4([169,254,0,0]),16]],loopback:[[new IPv4([127,0,0,0]),8]],private:[[new IPv4([10,0,0,0]),8],[new IPv4([172,16,0,0]),12],[new IPv4([192,168,0,0]),16]],reserved:[[new IPv4([192,0,0,0]),24],[new IPv4([192,0,2,0]),24],[new IPv4([192,88,99,0]),24],[new IPv4([198,51,100,0]),24],[new IPv4([203,0,113,0]),24],[new IPv4([240,0,0,0]),4]]};IPv4.prototype.range=function(){return ipaddr.subnetMatch(this,this.SpecialRanges)};IPv4.prototype.toIPv4MappedAddress=function(){return ipaddr.IPv6.parse("::ffff:"+this.toString())};return IPv4}();ipv4Part="(0?\\d+|0x[a-f0-9]+)";ipv4Regexes={fourOctet:new RegExp("^"+ipv4Part+"\\."+ipv4Part+"\\."+ipv4Part+"\\."+ipv4Part+"$","i"),longValue:new RegExp("^"+ipv4Part+"$","i")};ipaddr.IPv4.parser=function(string){var match,parseIntAuto,part,shift,value;parseIntAuto=function(string){if(string[0]==="0"&&string[1]!=="x"){return parseInt(string,8)}else{return parseInt(string)}};if(match=string.match(ipv4Regexes.fourOctet)){return function(){var i,len,ref,results;ref=match.slice(1,6);results=[];for(i=0,len=ref.length;i<len;i++){part=ref[i];results.push(parseIntAuto(part))}return results}()}else if(match=string.match(ipv4Regexes.longValue)){value=parseIntAuto(match[1]);return function(){var i,results;results=[];for(shift=i=0;i<=24;shift=i+=8){results.push(value>>shift&255)}return results}().reverse()}else{return null}};ipaddr.IPv6=function(){function IPv6(parts){var i,len,part;if(parts.length!==8){throw new Error("ipaddr: ipv6 part count should be 8")}for(i=0,len=parts.length;i<len;i++){part=parts[i];if(!(0<=part&&part<=65535)){throw new Error("ipaddr: ipv6 part should fit to two octets")}}this.parts=parts}IPv6.prototype.kind=function(){return"ipv6"};IPv6.prototype.toString=function(){var compactStringParts,i,len,part,pushPart,state,stringParts;stringParts=function(){var i,len,ref,results;ref=this.parts;results=[];for(i=0,len=ref.length;i<len;i++){part=ref[i];results.push(part.toString(16))}return results}.call(this);compactStringParts=[];pushPart=function(part){return compactStringParts.push(part)};state=0;for(i=0,len=stringParts.length;i<len;i++){part=stringParts[i];switch(state){case 0:if(part==="0"){pushPart("")}else{pushPart(part)}state=1;break;case 1:if(part==="0"){state=2}else{pushPart(part)}break;case 2:if(part!=="0"){pushPart("");pushPart(part);state=3}break;case 3:pushPart(part)}}if(state===2){pushPart("");pushPart("")}return compactStringParts.join(":")};IPv6.prototype.toByteArray=function(){var bytes,i,len,part,ref;bytes=[];ref=this.parts;for(i=0,len=ref.length;i<len;i++){part=ref[i];bytes.push(part>>8);bytes.push(part&255)}return bytes};IPv6.prototype.toNormalizedString=function(){var part;return function(){var i,len,ref,results;ref=this.parts;results=[];for(i=0,len=ref.length;i<len;i++){part=ref[i];results.push(part.toString(16))}return results}.call(this).join(":")};IPv6.prototype.match=function(other,cidrRange){if(other.kind()!=="ipv6"){throw new Error("ipaddr: cannot match ipv6 address with non-ipv6 one")}return matchCIDR(this.parts,other.parts,16,cidrRange)};IPv6.prototype.SpecialRanges={unspecified:[new IPv6([0,0,0,0,0,0,0,0]),128],linkLocal:[new IPv6([65152,0,0,0,0,0,0,0]),10],multicast:[new IPv6([65280,0,0,0,0,0,0,0]),8],loopback:[new IPv6([0,0,0,0,0,0,0,1]),128],uniqueLocal:[new IPv6([64512,0,0,0,0,0,0,0]),7],ipv4Mapped:[new IPv6([0,0,0,0,0,65535,0,0]),96],rfc6145:[new IPv6([0,0,0,0,65535,0,0,0]),96],rfc6052:[new IPv6([100,65435,0,0,0,0,0,0]),96],"6to4":[new IPv6([8194,0,0,0,0,0,0,0]),16],teredo:[new IPv6([8193,0,0,0,0,0,0,0]),32],reserved:[[new IPv6([8193,3512,0,0,0,0,0,0]),32]]};IPv6.prototype.range=function(){return ipaddr.subnetMatch(this,this.SpecialRanges)};IPv6.prototype.isIPv4MappedAddress=function(){return this.range()==="ipv4Mapped"};IPv6.prototype.toIPv4Address=function(){var high,low,ref;if(!this.isIPv4MappedAddress()){throw new Error("ipaddr: trying to convert a generic ipv6 address to ipv4")}ref=this.parts.slice(-2),high=ref[0],low=ref[1];return new ipaddr.IPv4([high>>8,high&255,low>>8,low&255])};return IPv6}();ipv6Part="(?:[0-9a-f]+::?)+";ipv6Regexes={native:new RegExp("^(::)?("+ipv6Part+")?([0-9a-f]+)?(::)?$","i"),transitional:new RegExp("^((?:"+ipv6Part+")|(?:::)(?:"+ipv6Part+")?)"+(ipv4Part+"\\."+ipv4Part+"\\."+ipv4Part+"\\."+ipv4Part+"$"),"i")};expandIPv6=function(string,parts){var colonCount,lastColon,part,replacement,replacementCount;if(string.indexOf("::")!==string.lastIndexOf("::")){return null}colonCount=0;lastColon=-1;while((lastColon=string.indexOf(":",lastColon+1))>=0){colonCount++}if(string[0]===":"){colonCount--}if(string[string.length-1]===":"){colonCount--}replacementCount=parts-colonCount;replacement=":";while(replacementCount--){replacement+="0:"}string=string.replace("::",replacement);if(string[0]===":"){string=string.slice(1)}if(string[string.length-1]===":"){string=string.slice(0,-1)}return function(){var i,len,ref,results;ref=string.split(":");results=[];for(i=0,len=ref.length;i<len;i++){part=ref[i];results.push(parseInt(part,16))}return results}()};ipaddr.IPv6.parser=function(string){var match,parts;if(string.match(ipv6Regexes["native"])){return expandIPv6(string,8)}else if(match=string.match(ipv6Regexes["transitional"])){parts=expandIPv6(match[1].slice(0,-1),6);if(parts){parts.push(parseInt(match[2])<<8|parseInt(match[3]));parts.push(parseInt(match[4])<<8|parseInt(match[5]));return parts}}return null};ipaddr.IPv4.isIPv4=ipaddr.IPv6.isIPv6=function(string){return this.parser(string)!==null};ipaddr.IPv4.isValid=ipaddr.IPv6.isValid=function(string){var e;try{new this(this.parser(string));return true}catch(error){e=error;return false}};ipaddr.IPv4.parse=ipaddr.IPv6.parse=function(string){var parts;parts=this.parser(string);if(parts===null){throw new Error("ipaddr: string is not formatted like ip address")}return new this(parts)};ipaddr.isValid=function(string){return ipaddr.IPv6.isValid(string)||ipaddr.IPv4.isValid(string)};ipaddr.parse=function(string){if(ipaddr.IPv6.isIPv6(string)){return ipaddr.IPv6.parse(string)}else if(ipaddr.IPv4.isIPv4(string)){return ipaddr.IPv4.parse(string)}else{throw new Error("ipaddr: the address has neither IPv6 nor IPv4 format")}};ipaddr.process=function(string){var addr;addr=this.parse(string);if(addr.kind()==="ipv6"&&addr.isIPv4MappedAddress()){return addr.toIPv4Address()}else{return addr}}}).call(this);